//*****************************************
//	RealTimeTimer [Ver.1.1]
//	
//	RealTimeTimer.h
//	RealTimeTimer.cpp
//
//  Copyright(c) 2002-2011 Yohei HOSHINO
//*****************************************

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h> 
#include "..\header\RealTimeTimer.h"

//#define MESSAGE_BEEP

HANDLE hTimerThread;
DWORD TimerThreadID;

long			Thread_freq;//freq[Hz]
LONGLONG		WaitCount;

volatile long	Thread_MsgLoop;
volatile double Difference;

LARGE_INTEGER		Thread_Frequency;


LONGLONG RealTimeTimerThread( LPVOID IntervalFunc );

BOOL  SetRealTimeTimer(long frequency)
{
	BOOL QPF;

	Thread_freq = frequency;

	QPF = QueryPerformanceFrequency(&Thread_Frequency);
	if(QPF == 0) MessageBox(NULL,"Performance counter is not available.","Info",MB_OK);

	Thread_MsgLoop = TRUE;

	WaitCount = Thread_Frequency.QuadPart/(LONGLONG)Thread_freq-1;

	hTimerThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)RealTimeTimerThread,0,CREATE_SUSPENDED,&TimerThreadID);
	SetThreadPriority(hTimerThread,THREAD_PRIORITY_HIGHEST);
	ResumeThread(hTimerThread);

	return QPF;
}

BOOL StartTimer()
{
	ResumeThread(hTimerThread);
	return TRUE;
}

LONGLONG RealTimeTimerThread(LPVOID IntervalFunc)
{
	LONGLONG		Thread_Step;
	
	LONGLONG		Thread_Difference;

	LONGLONG		Thread_Count, Thread_Count0;
	LARGE_INTEGER		Thread_PerformanceCount;
	
	Thread_Step = 0;
	Thread_Difference = 0;
	QueryPerformanceCounter(&Thread_PerformanceCount);
	Thread_Count = Thread_PerformanceCount.QuadPart;
	while( Thread_MsgLoop == TRUE )
	{
		// Wait
		SetThreadPriority(hTimerThread,THREAD_PRIORITY_TIME_CRITICAL);
		Thread_Count0 = Thread_Count;
		do{
			//\ptH[}X^C}[̌ݒl擾܂B
			QueryPerformanceCounter(&Thread_PerformanceCount);
			Thread_Count = Thread_PerformanceCount.QuadPart;
			Thread_Difference = Thread_Count - Thread_Count0;
		}while(  Thread_Difference < WaitCount );
		IntervalTask();
		SetThreadPriority(hTimerThread,THREAD_PRIORITY_HIGHEST);

#ifdef MESSAGE_BEEP		
		if(Thread_Step >= Thread_freq )
		{
			MessageBeep(0xFFFFFFFF);
			Thread_Step=0;
		}
		Thread_Step++;
#endif
		Difference = (double)(Thread_Difference+0)/(double)Thread_Frequency.QuadPart;

	}
	return Thread_Difference;
}

//DWORD RealTimeWait();
BOOL  EndRealTimeTimer()
{
	Thread_MsgLoop = FALSE;
	return WaitForSingleObject(hTimerThread,0)==WAIT_OBJECT_0;
}

